Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4645)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 4646)
@@ -1773,13 +1664,10 @@
           ENDIF
 
-          fac = ( simulated_time - dt_3d - time_vert(nt) )                     &
-                / ( time_vert(nt+1)-time_vert(nt) )
+          fac = ( simulated_time - dt_3d - time_vert(nt) ) / ( time_vert(nt+1)-time_vert(nt) )
 
 
           DO  k = nzb, nzt
-             sums_ls_l(k,0) = td_lsa_lpt(k,nt)                                 &
-                              + fac * ( td_lsa_lpt(k,nt+1) - td_lsa_lpt(k,nt) )
-             sums_ls_l(k,1) = td_lsa_q(k,nt)                                   &
-                              + fac * ( td_lsa_q(k,nt+1) - td_lsa_q(k,nt) )
+             sums_ls_l(k,0) = td_lsa_lpt(k,nt) + fac * ( td_lsa_lpt(k,nt+1) - td_lsa_lpt(k,nt) )
+             sums_ls_l(k,1) = td_lsa_q(k,nt)   + fac * ( td_lsa_q(k,nt+1)   - td_lsa_q(k,nt) )
           ENDDO
 
@@ -1787,11 +1675,9 @@
           sums_ls_l(nzt+1,1) = sums_ls_l(nzt,1)
 
-          IF ( large_scale_subsidence .AND. use_subsidence_tendencies )  THEN
+          IF ( large_scale_subsidence  .AND.  use_subsidence_tendencies )  THEN
 
              DO  k = nzb, nzt
-                sums_ls_l(k,2) = td_sub_lpt(k,nt) + fac *                      &
-                                 ( td_sub_lpt(k,nt+1) - td_sub_lpt(k,nt) )
-                sums_ls_l(k,3) = td_sub_q(k,nt) + fac *                        &
-                                 ( td_sub_q(k,nt+1) - td_sub_q(k,nt) )
+                sums_ls_l(k,2) = td_sub_lpt(k,nt) + fac * ( td_sub_lpt(k,nt+1) - td_sub_lpt(k,nt) )
+                sums_ls_l(k,3) = td_sub_q(k,nt)   + fac * ( td_sub_q(k,nt+1)   - td_sub_q(k,nt) )
              ENDDO
 
@@ -1806,5 +1692,5 @@
        !$OMP PARALLEL PRIVATE( i, j, k, tn )
        !$ tn = omp_get_thread_num()
-       IF ( radiation .AND. radiation_scheme == 'rrtmg' )  THEN
+       IF ( radiation  .AND.  radiation_scheme == 'rrtmg' )  THEN
           !$OMP DO
           DO  i = nxl, nxr
@@ -1813,20 +1699,12 @@
                    flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 
-                   sums_l(k,100,tn)  = sums_l(k,100,tn)  + rad_lw_in(k,j,i)    &
-                                       * rmask(j,i,sr) * flag
-                   sums_l(k,101,tn)  = sums_l(k,101,tn)  + rad_lw_out(k,j,i)   &
-                                       * rmask(j,i,sr) * flag
-                   sums_l(k,102,tn)  = sums_l(k,102,tn)  + rad_sw_in(k,j,i)    &
-                                       * rmask(j,i,sr) * flag
-                   sums_l(k,103,tn)  = sums_l(k,103,tn)  + rad_sw_out(k,j,i)   &
-                                       * rmask(j,i,sr) * flag
-                   sums_l(k,104,tn)  = sums_l(k,104,tn)  + rad_lw_cs_hr(k,j,i) &
-                                       * rmask(j,i,sr) * flag
-                   sums_l(k,105,tn)  = sums_l(k,105,tn)  + rad_lw_hr(k,j,i)    &
-                                       * rmask(j,i,sr) * flag
-                   sums_l(k,106,tn)  = sums_l(k,106,tn)  + rad_sw_cs_hr(k,j,i) &
-                                       * rmask(j,i,sr) * flag
-                   sums_l(k,107,tn)  = sums_l(k,107,tn)  + rad_sw_hr(k,j,i)    &
-                                       * rmask(j,i,sr) * flag
+                   sums_l(k,100,tn)  = sums_l(k,100,tn) + rad_lw_in(k,j,i)    * rmask(j,i,sr) * flag
+                   sums_l(k,101,tn)  = sums_l(k,101,tn) + rad_lw_out(k,j,i)   * rmask(j,i,sr) * flag
+                   sums_l(k,102,tn)  = sums_l(k,102,tn) + rad_sw_in(k,j,i)    * rmask(j,i,sr) * flag
+                   sums_l(k,103,tn)  = sums_l(k,103,tn) + rad_sw_out(k,j,i)   * rmask(j,i,sr) * flag
+                   sums_l(k,104,tn)  = sums_l(k,104,tn) + rad_lw_cs_hr(k,j,i) * rmask(j,i,sr) * flag
+                   sums_l(k,105,tn)  = sums_l(k,105,tn) + rad_lw_hr(k,j,i)    * rmask(j,i,sr) * flag
+                   sums_l(k,106,tn)  = sums_l(k,106,tn) + rad_sw_cs_hr(k,j,i) * rmask(j,i,sr) * flag
+                   sums_l(k,107,tn)  = sums_l(k,107,tn) + rad_sw_hr(k,j,i)    * rmask(j,i,sr) * flag
                 ENDDO
              ENDDO
@@ -1848,7 +1726,7 @@
                                       sums_l(:,45:pr_palm,i)
              IF ( max_pr_user > 0 )  THEN
-                sums_l(:,pr_palm+1:pr_palm+max_pr_user,0) = &
-                                   sums_l(:,pr_palm+1:pr_palm+max_pr_user,0) + &
-                                   sums_l(:,pr_palm+1:pr_palm+max_pr_user,i)
+                sums_l(:,pr_palm+1:pr_palm+max_pr_user,0) =                                        &
+                                                       sums_l(:,pr_palm+1:pr_palm+max_pr_user,0) + &
+                                                       sums_l(:,pr_palm+1:pr_palm+max_pr_user,i)
              ENDIF
 
@@ -1877,9 +1755,8 @@
 !--    Compute total sum from local sums
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), ngp_sums, MPI_REAL,   &
-                           MPI_SUM, comm2d, ierr )
+       CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), ngp_sums, MPI_REAL, MPI_SUM, comm2d, ierr )
        IF ( large_scale_forcing )  THEN
-          CALL MPI_ALLREDUCE( sums_ls_l(nzb,2), sums(nzb,83), ngp_sums_ls,     &
-                              MPI_REAL, MPI_SUM, comm2d, ierr )
+          CALL MPI_ALLREDUCE( sums_ls_l(nzb,2), sums(nzb,83), ngp_sums_ls, MPI_REAL, MPI_SUM,      &
+                              comm2d, ierr )
        ENDIF
 
@@ -1887,6 +1764,6 @@
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
           DO  i = 1, max_pr_cs
-             CALL MPI_ALLREDUCE( sums_l(nzb,pr_palm+max_pr_user+i,0),          &
-                                 sums(nzb,pr_palm+max_pr_user+i),              &
+             CALL MPI_ALLREDUCE( sums_l(nzb,pr_palm+max_pr_user+i,0),                              &
+                                 sums(nzb,pr_palm+max_pr_user+i),                                  &
                                  nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d, ierr )
           ENDDO
@@ -1910,9 +1787,9 @@
 
 !
-!--    Final values are obtained by division by the total number of grid points
-!--    used for summation. After that store profiles.
-!--    Check, if statistical regions do contain at least one grid point at the
-!--    respective k-level, otherwise division by zero will lead to undefined
-!--    values, which may cause e.g. problems with NetCDF output
+!--    Final values are obtained by division by the total number of grid points used for summation.
+!--    After that store profiles.
+!--    Check, if statistical regions do contain at least one grid point at the respective k-level,
+!--    otherwise division by zero will lead to undefined values, which may cause e.g. problems with
+!--    NetCDF output.
 !--    Profiles:
        DO  k = nzb, nzt+1
@@ -1942,42 +1819,36 @@
 
 !--    u* and so on
-!--    As sums(nzb:nzb+3,pr_palm) are full 2D arrays (us, usws, vsws, ts) whose
-!--    size is always ( nx + 1 ) * ( ny + 1 ), defined at the first grid layer
-!--    above the topography, they are being divided by ngp_2dh(sr)
-       sums(nzb:nzb+3,pr_palm)    = sums(nzb:nzb+3,pr_palm)    / &
-                                    ngp_2dh(sr)
-       sums(nzb+12,pr_palm)       = sums(nzb+12,pr_palm)       / &    ! qs
-                                    ngp_2dh(sr)
-       sums(nzb+13,pr_palm)       = sums(nzb+13,pr_palm)       / &    ! ss
-                                    ngp_2dh(sr)
-       sums(nzb+14,pr_palm)       = sums(nzb+14,pr_palm)       / &    ! surface temperature
-                                    ngp_2dh(sr)
+!--    As sums(nzb:nzb+3,pr_palm) are full 2D arrays (us, usws, vsws, ts) whose size is always
+!--    ( nx + 1 ) * ( ny + 1 ), defined at the first grid layer above the topography, they are
+!--    divided by ngp_2dh(sr)
+       sums(nzb:nzb+3,pr_palm)    = sums(nzb:nzb+3,pr_palm)  /  ngp_2dh(sr)
+       sums(nzb+12,pr_palm)       = sums(nzb+12,pr_palm)     /  ngp_2dh(sr)    ! qs
+       sums(nzb+13,pr_palm)       = sums(nzb+13,pr_palm)     /  ngp_2dh(sr)    ! ss
+       sums(nzb+14,pr_palm)       = sums(nzb+14,pr_palm)     /  ngp_2dh(sr)    ! surface temperature
+
 !--    eges, e*
-       sums(nzb+4:nzb+5,pr_palm)  = sums(nzb+4:nzb+5,pr_palm)  / &
-                                    ngp_3d(sr)
+       sums(nzb+4:nzb+5,pr_palm)  = sums(nzb+4:nzb+5,pr_palm)  /  ngp_3d(sr)
 !--    Old and new divergence
-       sums(nzb+9:nzb+10,pr_palm) = sums(nzb+9:nzb+10,pr_palm) / &
-                                    ngp_3d_inner(sr)
+       sums(nzb+9:nzb+10,pr_palm) = sums(nzb+9:nzb+10,pr_palm) /  ngp_3d_inner(sr)
 
 !--    User-defined profiles
        IF ( max_pr_user > 0 )  THEN
           DO  k = nzb, nzt+1
-             sums(k,pr_palm+1:pr_palm+max_pr_user) = &
-                                    sums(k,pr_palm+1:pr_palm+max_pr_user) / &
-                                    ngp_2dh_s_inner(k,sr)
-          ENDDO
-       ENDIF
-
-       IF ( air_chemistry ) THEN
+             sums(k,pr_palm+1:pr_palm+max_pr_user) =  sums(k,pr_palm+1:pr_palm+max_pr_user) /      &
+                                                      ngp_2dh_s_inner(k,sr)
+          ENDDO
+       ENDIF
+
+       IF ( air_chemistry )  THEN
           IF ( max_pr_cs > 0 )  THEN
              DO k = nzb, nzt+1
-                sums(k, pr_palm+1:pr_palm+max_pr_user+max_pr_cs) = &
-                                 sums(k, pr_palm+1:pr_palm+max_pr_user+max_pr_cs) / &
-                                 ngp_2dh_s_inner(k,sr)
+                sums(k, pr_palm+1:pr_palm+max_pr_user+max_pr_cs) =                                 &
+                                                sums(k, pr_palm+1:pr_palm+max_pr_user+max_pr_cs) / &
+                                                ngp_2dh_s_inner(k,sr)
              ENDDO
           ENDIF
        ENDIF
 
-       IF ( salsa ) THEN
+       IF ( salsa )  THEN
           IF ( max_pr_salsa > 0 )  THEN
              DO k = nzb, nzt+1
@@ -2020,5 +1891,5 @@
        hom(:,1,37,sr) = sums(:,37)     ! w*e*
        hom(:,1,38,sr) = sums(:,38)     ! w*3
-       hom(:,1,39,sr) = sums(:,38) / ( abs( sums(:,32) ) + 1E-20_wp )**1.5_wp   ! Sw
+       hom(:,1,39,sr) = sums(:,38) / ( ABS( sums(:,32) ) + 1E-20_wp )**1.5_wp   ! Sw
        hom(:,1,40,sr) = sums(:,40)     ! p
        hom(:,1,45,sr) = sums(:,45)     ! w"vpt"
@@ -2124,5 +1995,5 @@
        hom(:,1,120,sr) = rho_air_zw    ! rho_air_zw in Kg/m^3
 
-       IF ( kolmogorov_length_scale ) THEN
+       IF ( kolmogorov_length_scale )  THEN
           hom(:,1,121,sr) = sums(:,121) * 1E3_wp  ! eta in mm
        ENDIF
@@ -2152,14 +2023,13 @@
 !
 !--    Determine the boundary layer height using two different schemes.
-!--    First scheme: Starting from the Earth's (Ocean's) surface, look for the
-!--    first relative minimum (maximum) of the total heat flux.
-!--    The corresponding height is assumed as the boundary layer height, if it
-!--    is less than 1.5 times the height where the heat flux becomes negative
-!--    (positive) for the first time. Attention: the resolved vertical sensible
-!--    heat flux (hom(:,1,17,sr) = w*pt*) is not known at the beginning because
-!--    the calculation happens in advec_s_ws which is called after
-!--    flow_statistics. Therefore z_i is directly taken from restart data at
-!--    the beginning of restart runs.
-       IF ( TRIM( initializing_actions ) /= 'read_restart_data' .OR.           &
+!--    First scheme: Starting from the Earth's (Ocean's) surface, look for the first relative
+!--    minimum (maximum) of the total heat flux.
+!--    The corresponding height is assumed as the boundary layer height, if it is less than 1.5
+!--    times the height where the heat flux becomes negative (positive) for the first time.
+!--    Attention: the resolved vertical sensible heat flux (hom(:,1,17,sr) = w*pt*) is not known at
+!--    the beginning because the calculation happens in advec_s_ws which is called after
+!--    flow_statistics. Therefore z_i is directly taken from restart data at the beginning of
+!--    restart runs.
+       IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .OR.                              &
             simulated_time_at_begin /= simulated_time ) THEN
 
@@ -2173,6 +2043,5 @@
                    height = zw(k)
                 ENDIF
-                IF ( hom(k,1,18,sr) < -1.0E-8_wp  .AND.                        &
-                     hom(k-1,1,18,sr) > hom(k,1,18,sr) )  THEN
+                IF ( hom(k,1,18,sr) < -1.0E-8_wp  .AND.  hom(k-1,1,18,sr) > hom(k,1,18,sr) )  THEN
                    IF ( zw(k) < 1.5_wp * height )  THEN
                       z_i(1) = zw(k)
@@ -2189,6 +2058,5 @@
                    height = zw(k)
                 ENDIF
-                IF ( hom(k,1,18,sr) < -1.0E-8_wp  .AND.                        &
-                     hom(k+1,1,18,sr) > hom(k,1,18,sr) )  THEN
+                IF ( hom(k,1,18,sr) < -1.0E-8_wp  .AND.  hom(k+1,1,18,sr) > hom(k,1,18,sr) )  THEN
                    IF ( zw(k) < 1.5_wp * height )  THEN
                       z_i(1) = zw(k)
@@ -2202,9 +2070,8 @@
 
 !
-!--       Second scheme: Gradient scheme from Sullivan et al. (1998), modified
-!--       by Uhlenbrock(2006). The boundary layer height is the height with the
-!--       maximal local temperature gradient: starting from the second (the
-!--       last but one) vertical gridpoint, the local gradient must be at least
-!--       0.2K/100m and greater than the next four gradients.
+!--       Second scheme: Gradient scheme from Sullivan et al. (1998), modified by Uhlenbrock(2006).
+!--       The boundary layer height is the height with the maximal local temperature gradient:
+!--       starting from the second (the last but one) vertical gridpoint, the local gradient must be
+!--       at least 0.2K/100m and greater than the next four gradients.
 !--       WARNING: The threshold value of 0.2K/100m must be adjusted for the
 !--       ocean case!
@@ -2217,6 +2084,6 @@
           IF ( ocean_mode )  THEN
              DO  k = nzt+1, nzb+5, -1
-                IF ( dptdz(k) > dptdz_threshold  .AND.                         &
-                     dptdz(k) > dptdz(k-1)  .AND.  dptdz(k) > dptdz(k-2)  .AND.&
+                IF ( dptdz(k) > dptdz_threshold  .AND.                                             &
+                     dptdz(k) > dptdz(k-1)  .AND.  dptdz(k) > dptdz(k-2)  .AND.                    &
                      dptdz(k) > dptdz(k-3)  .AND.  dptdz(k) > dptdz(k-4) )  THEN
                    z_i(2) = zw(k-1)
@@ -2226,6 +2093,6 @@
           ELSE
              DO  k = nzb+1, nzt-3
-                IF ( dptdz(k) > dptdz_threshold  .AND.                         &
-                     dptdz(k) > dptdz(k+1)  .AND.  dptdz(k) > dptdz(k+2)  .AND.&
+                IF ( dptdz(k) > dptdz_threshold  .AND.                                             &
+                     dptdz(k) > dptdz(k+1)  .AND.  dptdz(k) > dptdz(k+2)  .AND.                    &
                      dptdz(k) > dptdz(k+3)  .AND.  dptdz(k) > dptdz(k+4) )  THEN
                    z_i(2) = zw(k-1)
@@ -2241,6 +2108,6 @@
 
 !
-!--    Determine vertical index which is nearest to the mean surface level
-!--    height of the respective statistic region
+!--    Determine vertical index which is nearest to the mean surface level height of the respective
+!--    statistic region
        DO  k = nzb, nzt
           IF ( zw(k) >= mean_surface_level_height(sr) )  THEN
@@ -2251,17 +2118,15 @@
 
 !
-!--    Computation of both the characteristic vertical velocity and
-!--    the characteristic convective boundary layer temperature.
-!--    The inversion height entering into the equation is defined with respect
-!--    to the mean surface level height of the respective statistic region.
-!--    The horizontal average at surface level index + 1 is input for the
-!--    average temperature.
-       IF ( hom(k_surface_level,1,18,sr) > 1.0E-8_wp  .AND.  z_i(1) /= 0.0_wp )&
-       THEN
-          hom(nzb+8,1,pr_palm,sr) =                                            &
-             ( g / hom(k_surface_level+1,1,4,sr) *                             &
-             ( hom(k_surface_level,1,18,sr) /                                  &
-             ( heatflux_output_conversion(nzb) * rho_air(nzb) ) )              &
-             * ABS( z_i(1) - mean_surface_level_height(sr) ) )**0.333333333_wp
+!--    Computation of both the characteristic vertical velocity and the characteristic convective
+!--    boundary layer temperature.
+!--    The inversion height entering into the equation is defined with respect to the mean surface
+!--    level height of the respective statistic region.
+!--    The horizontal average at surface level index + 1 is input for the average temperature.
+       IF ( hom(k_surface_level,1,18,sr) > 1.0E-8_wp  .AND.  z_i(1) /= 0.0_wp )  THEN
+          hom(nzb+8,1,pr_palm,sr) =                                                                &
+                                   ( g / hom(k_surface_level+1,1,4,sr) *                           &
+                                   ( hom(k_surface_level,1,18,sr) /                                &
+                                   ( heatflux_output_conversion(nzb) * rho_air(nzb) ) )            &
+                                   * ABS( z_i(1) - mean_surface_level_height(sr) ) )**0.333333333_wp
        ELSE
           hom(nzb+8,1,pr_palm,sr)  = 0.0_wp
@@ -2269,9 +2134,8 @@
 
 !
-!--    Collect the time series quantities. Please note, timeseries quantities
-!--    which are collected from horizontally averaged profiles, e.g. wpt
-!--    or pt(zp), are treated specially. In case of elevated model surfaces,
-!--    index nzb+1 might be within topography and data will be zero. Therefore,
-!--    take value for the first atmosphere index, which is topo_min_level+1.
+!--    Collect the time series quantities. Please note, timeseries quantities which are collected
+!--    from horizontally averaged profiles, e.g. wpt or pt(zp), are treated specially. In case of
+!--    elevated model surfaces, index nzb+1 might be within topography and data will be zero.
+!--    Therefore, take value for the first atmosphere index, which is topo_min_level+1.
        ts_value(1,sr) = hom(nzb+4,1,pr_palm,sr)        ! E
        ts_value(2,sr) = hom(nzb+5,1,pr_palm,sr)        ! E*
Index: palm/trunk/SOURCE/global_min_max.f90
===================================================================
--- palm/trunk/SOURCE/global_min_max.f90	(revision 4645)
+++ palm/trunk/SOURCE/global_min_max.f90	(revision 4646)
@@ -1,36 +1,37 @@
-!> @file global_min_max.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4429 2020-02-27 15:24:30Z raasch
 ! bugfix: cpp-directives added for serial mode
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! OpenACC support added
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! Corrected "Former revisions" section
@@ -43,14 +44,14 @@
 ! ------------
 !> Determine the array minimum/maximum and the corresponding indices.
-!------------------------------------------------------------------------------!
- SUBROUTINE global_min_max( i1, i2, j1, j2, k1, k2, ar, mode, offset, value, &
-                            value_ijk, value1, value1_ijk )
- 
-
-    USE indices,                                                               &
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE global_min_max( i1, i2, j1, j2, k1, k2, ar, mode, offset, value, value_ijk, value1,    &
+                            value1_ijk )
+
+
+    USE indices,                                                                                   &
         ONLY:  nbgp, ny, nx
-        
+
     USE kinds
-    
+
     USE pegrid
 
@@ -72,16 +73,19 @@
     INTEGER(iwp) ::  k1             !<
     INTEGER(iwp) ::  k2             !<
-    INTEGER(iwp) ::  fmax_ijk(3)    !<
-    INTEGER(iwp) ::  fmax_ijk_l(3)  !<
-    INTEGER(iwp) ::  fmin_ijk(3)    !<
-    INTEGER(iwp) ::  fmin_ijk_l(3)  !<
     INTEGER(iwp) ::  value_ijk(3)   !<
-    
-    INTEGER(iwp), OPTIONAL ::  value1_ijk(3)  !<
-    
-    REAL(wp) ::  offset                 !<
-    REAL(wp) ::  value                  !<
+
+    INTEGER(iwp), DIMENSION(3) ::  fmax_ijk    !<
+    INTEGER(iwp), DIMENSION(3) ::  fmax_ijk_l  !<
+    INTEGER(iwp), DIMENSION(3) ::  fmin_ijk    !<
+    INTEGER(iwp), DIMENSION(3) ::  fmin_ijk_l  !<
+
+    INTEGER(iwp), DIMENSION(3), OPTIONAL ::  value1_ijk  !<
+
+    REAL(wp) ::  offset            !<
+    REAL(wp) ::  value             !<
+    REAL(wp), OPTIONAL ::  value1  !<
+
     REAL(wp) ::  ar(i1:i2,j1:j2,k1:k2)  !<
-    
+
 #if defined( __ibm )
     REAL(sp) ::  fmax(2)    !<
@@ -89,17 +93,17 @@
     REAL(sp) ::  fmin(2)    !<
     REAL(sp) ::  fmin_l(2)  !<
-             ! on 32bit-machines MPI_2REAL must not be replaced 
+             ! on 32bit-machines MPI_2REAL must not be replaced
              ! by MPI_2DOUBLE_PRECISION
 #else
-    REAL(wp) ::  fmax(2)    !<
-    REAL(wp) ::  fmax_l(2)  !<
-    REAL(wp) ::  fmin(2)    !<
-    REAL(wp) ::  fmin_l(2)  !<
-#endif
+    REAL(wp), DIMENSION(2) ::  fmax    !<
+    REAL(wp), DIMENSION(2) ::  fmax_l  !<
+    REAL(wp), DIMENSION(2) ::  fmin    !<
+    REAL(wp), DIMENSION(2) ::  fmin_l  !<
+#endif
+
 #if defined( _OPENACC )
+    INTEGER(iwp) ::  count_eq   !< counter for locations of maximum
     REAL(wp)     ::  red        !< scalar for reduction with OpenACC
-    INTEGER(iwp) ::  count_eq   !< counter for locations of maximum
-#endif
-    REAL(wp), OPTIONAL ::  value1  !<
+#endif
 
 
@@ -119,6 +123,5 @@
        fmin_l(2)  = myid
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( fmin_l, fmin, 1, MPI_2REAL, MPI_MINLOC, comm2d, &
-                           ierr )
+       CALL MPI_ALLREDUCE( fmin_l, fmin, 1, MPI_2REAL, MPI_MINLOC, comm2d, ierr )
 
 !
@@ -127,6 +130,5 @@
        IF ( id_fmin /= 0 )  THEN
           IF ( myid == 0 )  THEN
-             CALL MPI_RECV( fmin_ijk, 3, MPI_INTEGER, id_fmin, 0, comm2d, &
-                            status, ierr )
+             CALL MPI_RECV( fmin_ijk, 3, MPI_INTEGER, id_fmin, 0, comm2d, status, ierr )
           ELSEIF ( myid == id_fmin )  THEN
              CALL MPI_SEND( fmin_ijk_l, 3, MPI_INTEGER, 0, 0, comm2d, ierr )
@@ -160,6 +162,5 @@
        fmax_l(2)  = myid
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( fmax_l, fmax, 1, MPI_2REAL, MPI_MAXLOC, comm2d, &
-                           ierr )
+       CALL MPI_ALLREDUCE( fmax_l, fmax, 1, MPI_2REAL, MPI_MAXLOC, comm2d, ierr )
 
 !
@@ -168,6 +169,5 @@
        IF ( id_fmax /= 0 )  THEN
           IF ( myid == 0 )  THEN
-             CALL MPI_RECV( fmax_ijk, 3, MPI_INTEGER, id_fmax, 0, comm2d, &
-                            status, ierr )
+             CALL MPI_RECV( fmax_ijk, 3, MPI_INTEGER, id_fmax, 0, comm2d, status, ierr )
           ELSEIF ( myid == id_fmax )  THEN
              CALL MPI_SEND( fmax_ijk_l, 3, MPI_INTEGER, 0, 0, comm2d, ierr )
@@ -177,5 +177,5 @@
        ENDIF
 !
-!--    send the indices of the just determined array maximum to other PEs
+!--    Send the indices of the just determined array maximum to other PEs
        CALL MPI_BCAST( fmax_ijk, 3, MPI_INTEGER, 0, comm2d, ierr )
 #else
@@ -226,6 +226,6 @@
        IF ( count_eq == 1 ) THEN
 !
-!--       We found a single maximum element and correctly got its position. Transfer its
-!--       value to handle the negative case correctly.
+!--       We found a single maximum element and correctly got its position. Transfer its value to
+!--       handle the negative case correctly.
           !$ACC UPDATE HOST(ar(fmax_ijk_l(1):fmax_ijk_l(1),fmax_ijk_l(2),fmax_ijk_l(3)))
        ELSE
@@ -257,5 +257,5 @@
 #if defined( _OPENACC )
 !
-!--       Close ELSE case from above
+!--    Close ELSE case from above
        ENDIF
 #endif
@@ -263,6 +263,5 @@
 !
 !--    Set a flag in case that the determined value is negative.
-!--    A constant offset has to be subtracted in order to handle the special
-!--    case i=0 correctly
+!--    A constant offset has to be subtracted in order to handle the special case i=0 correctly.
        IF ( ar(fmax_ijk_l(1),fmax_ijk_l(2),fmax_ijk_l(3)) < 0.0_wp )  THEN
           fmax_ijk_l(1) = -fmax_ijk_l(1) - 10
@@ -272,6 +271,5 @@
        fmax_l(2)  = myid
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( fmax_l, fmax, 1, MPI_2REAL, MPI_MAXLOC, comm2d, &
-                           ierr )
+       CALL MPI_ALLREDUCE( fmax_l, fmax, 1, MPI_2REAL, MPI_MAXLOC, comm2d, ierr )
 
 !
@@ -280,6 +278,5 @@
        IF ( id_fmax /= 0 )  THEN
           IF ( myid == 0 )  THEN
-             CALL MPI_RECV( fmax_ijk, 3, MPI_INTEGER, id_fmax, 0, comm2d, &
-                            status, ierr )
+             CALL MPI_RECV( fmax_ijk, 3, MPI_INTEGER, id_fmax, 0, comm2d, status, ierr )
           ELSEIF ( myid == id_fmax )  THEN
              CALL MPI_SEND( fmax_ijk_l, 3, MPI_INTEGER, 0, 0, comm2d, ierr )
@@ -311,7 +308,7 @@
           DO  j = j1, j2
 !
-!--          Attention: the lowest gridpoint is excluded here, because there
-!--          ---------  is no advection at nzb=0 and mode 'absoff' is only
-!--                     used for calculating u,v extrema for CFL-criteria
+!--          Attention: the lowest gridpoint is excluded here, because there is no advection at
+!--          ---------- nzb=0 and mode 'absoff' is only used for calculating u,v extrema for
+!--                     CFL-criteria.
              DO  i = i1+1, i2
                 IF ( ABS( ar(i,j,k) - offset ) > fmax_l(1) )  THEN
@@ -327,6 +324,5 @@
 !
 !--    Set a flag in case that the determined value is negative.
-!--    A constant offset has to be subtracted in order to handle the special
-!--    case i=0 correctly
+!--    A constant offset has to be subtracted in order to handle the special case i=0 correctly.
        IF ( ar(fmax_ijk_l(1),fmax_ijk_l(2),fmax_ijk_l(3)) < 0.0_wp )  THEN
           fmax_ijk_l(1) = -fmax_ijk_l(1) - 10
@@ -336,6 +332,5 @@
        fmax_l(2)  = myid
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( fmax_l, fmax, 1, MPI_2REAL, MPI_MAXLOC, comm2d, &
-                           ierr )
+       CALL MPI_ALLREDUCE( fmax_l, fmax, 1, MPI_2REAL, MPI_MAXLOC, comm2d, ierr )
 
 !
@@ -344,6 +339,5 @@
        IF ( id_fmax /= 0 )  THEN
           IF ( myid == 0 )  THEN
-             CALL MPI_RECV( fmax_ijk, 3, MPI_INTEGER, id_fmax, 0, comm2d, &
-                            status, ierr )
+             CALL MPI_RECV( fmax_ijk, 3, MPI_INTEGER, id_fmax, 0, comm2d, status, ierr )
           ELSEIF ( myid == id_fmax )  THEN
              CALL MPI_SEND( fmax_ijk_l, 3, MPI_INTEGER, 0, 0, comm2d, ierr )
